; ==============================================================================
;	MGSDRV
;
;  Copyright (C) 2020 Takayuki Hara (HRA!)
;  All rights reserved.
;                           http://hraroom.s602.xrea.com/msx/software/mgsp.html
;
;  {\tgEFAі{\tgEFAɊÂč쐬ꂽh́Aȉ̏
;  ꍇɌAĔЕzюgp܂B
;
;  1.\[XR[h`ōĔЕzꍇAL̒쌠\A{ꗗAщL
;    Ɛӏ̂܂܂̌`ŕێ邱ƁB
;  2.oCi`ōĔЕzꍇAЕzɕt̃hLg̎ɁAL
;    쌠\A{ꗗAщLƐӏ܂߂邱ƁB
;  3.ʂɂ鎖ŐȂɁA{\tgEFA̔AяƓIȐi⊈
;    ɎgpȂƁB
;
;  {\tgEFÁA쌠҂ɂāû܂܁v񋟂Ă܂B쌠҂́A
;  ړIւ̓K̕ۏ؁Ai̕ۏ؁A܂Ɍ肳ȂAȂ閾
;  I͈ÖقȕۏؐӔC܂B쌠҂́AR̂킸AQ
;  ̌킸AӔC̍_ł邩iӔCł邩iߎ
;  ̑́js@sׂł邩킸Aɂ̂悤ȑQ\m
;  ĂƂĂA{\tgEFA̎gpɂĔi֕i܂͑pT
;  [rX̒BAgp̑rAf[^̑rAv̑rAƖ̒f܂߁A܂
;  Ɍ肳ȂjڑQAԐڑQAIȑQAʑQAIQA
;  ͌ʑQɂāAؐӔC𕉂Ȃ̂Ƃ܂B
;
;  Note that above Japanese version license is the formal document.
;  The following translation is only for reference.
;
;  Redistribution and use of this software or any derivative works,
;  are permitted provided that the following conditions are met:
;
;  1. Redistributions of source code must retain the above copyright
;     notice, this list of conditions and the following disclaimer.
;  2. Redistributions in binary form must reproduce the above
;     copyright notice, this list of conditions and the following
;     disclaimer in the documentation and/or other materials
;     provided with the distribution.
;  3. Redistributions may not be sold, nor may they be used in a
;     commercial product or activity without specific prior written
;     permission.
;
;  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
;  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
;  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
;  FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
;  COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
;  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
;  BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
;  LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
;  CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
;  LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
;  ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
;  POSSIBILITY OF SUCH DAMAGE.
; ------------------------------------------------------------------------------
;	Date		Author	Ver		Description
;	2020/9/22	t.hara	1.0		1st release
; ==============================================================================

mgs_song_data	:= 0x8000
mgs_song_size	:= 0x4000
mgs_song_title	:= 0x8008

; ==============================================================================
;	init_mgsdrv
;	input)
;		--
;	output)
;		Zf .... 0: G[, 1: 
;	comment)
;		PATH̒ʂꏊ MGSDRV.COM oA}bp[mۂ
;		ɓǂݍ
;		}bp[̏̕ςłKvB
; ==============================================================================
		scope	init_mgsdrv
init_mgsdrv::
		; MGSDRVp̃mۂ
		xor		a, a
		ld		b, a					; vC}[}bp[
		call	mapper_all_seg			; 1ZOg
		jp		c, error_exit
		ld		[mgs_id_drvseg], a

		ld		a, b					; A = 0
		call	mapper_all_seg			; 1ZOg
		jp		c, error_exit
		ld		[mgs_id_datseg], a

		ld		a, [ramad1]
		ld		[mgs_id_drvslt], a
		ld		[mgs_id_datslt], a

		and		a, 0x03
		ld		b, a
		rlca
		rlca
		or		a, b
		rlca
		rlca
		or		a, b
		rlca
		rlca
		or		a, b
		ld		[mgsdrv_slot], a

		ld		a, [ramad1]
		and		a, 0x0C
		ld		b, a
		rlca
		rlca
		or		a, b
		rlca
		rlca
		or		a, b
		rlca
		rlca
		or		a, b
		ld		[mgsdrv_exp_slot], a

		; MGSDRV.COM J
		ld		de, s_mgsdrv_com
		call	open_file_on_path_env
		dec		a
		ret		nz						; G[Ȃ Zf = 0 ɂĔ

		; page1, page2 ̃ZOgԍobNAbv
		call	mapper_get_p1
		ld		[backup_segment1], a
		call	mapper_get_p2
		ld		[backup_segment2], a

		; page1, page2  MGSDRV ̃ZOgɐ؂ւ
		ld		a, [mgs_id_drvseg]
		call	mapper_put_p1
		ld		a, [mgs_id_datseg]
		call	mapper_put_p2

		; MGSDRV.COM ǂݍ
		ld			c, D2F_READ
		ld			a, [file_handle]
		ld			b, a
		ld			de, 0x6000 - 0x000D		; load address
		ld			hl, 0x200D				; size
		call		safe_bdos
		or			a, a
		ret			nz

		; t@C
		ld			c, D2F_CLOSE
		ld			a, [file_handle]
		ld			b, a
		call		safe_bdos

		; MGSDRV
		call		mgs_sysck
		ld			[mgs_id_mgsver], hl
		ld			[mgs_id_mibadr], ix
		ld			[mgs_id_trwadr], iy
		ld			[mgs_id_trwsiz], bc

		; H.TIMI荞݂tbN
	mgsdrv_h_timi_rel := 0xC000
		di
		ld			de, old_h_timi
		ld			hl, h_timi
		ld			bc, 5
		ldir

		ld			de, mgsdrv_h_timi_rel
		ld			hl, mgsdrv_h_timi
		ld			bc, mgsdrv_h_timi_end - mgsdrv_h_timi
		ldir

		ld			a, 0xC3				; JP xxxx 
		ld			[h_timi], a
		ld			hl, mgsdrv_h_timi_rel
		ld			[h_timi + 1], hl
		ei

		; }bp[߂
		ld			a, [backup_segment1]
		call		mapper_put_p1
		ld			a, [backup_segment2]
		call		mapper_put_p2
		xor			a, a
		ret

error_exit:
		xor			a, a
		inc			a						; Zf = 0 ɂĔ (G[)
		ret

s_mgsdrv_com:
		ds		"MGSDRV.COM"
		db		0
		endscope

; ==============================================================================
;	term_mgsdrv
; ==============================================================================
		scope	term_mgsdrv
term_mgsdrv::
		di
		ld			de, h_timi
		ld			hl, old_h_timi
		ld			bc, 5
		ldir
		ei
		ret
		endscope

; ==============================================================================
;	MGSDRṼgbN[NNA
; ==============================================================================
		scope		clear_mgsdrv_track_work
clear_mgsdrv_track_work::
		call		stop_song

		di
		ld			hl, [mgs_id_trwsiz]
		ld			c, l
		ld			b, h
		add			hl, hl
		add			hl, hl
		add			hl, hl
		add			hl, hl
		add			hl, bc
		ld			c, l
		ld			b, h
		ld			hl, [mgs_id_trwadr]
		ld			de, [mgs_id_trwadr]
		inc			de
		dec			bc
		xor			a, a
		ld			[hl], a
		ldir
		ei
		ret
		endscope

; ==============================================================================
;	Xbg\MGSDRVpɂ
; ==============================================================================
		scope		change_mgsdrv_slot
change_mgsdrv_slot::
		; change slot of page1 (mgsdrv body)
		ld			h, 0x40
		ld			a, [mgs_id_drvslt]
		call		enaslt

		; change slot of page2 (song data)
		ld			h, 0x80
		ld			a, [mgs_id_datslt]
		call		enaslt

		; change mapper segment of page1
		ld			a, [mgs_id_drvseg]
		call		mapper_put_p1

		; change mapper segment of page2
		ld			a, [mgs_id_datseg]
		call		mapper_put_p2
		ei
		ret
		endscope

; ==============================================================================
;	load_mgs_file
;	input)
;		de .... t@C̃AhX (ASCIIZ)
;	output)
;		Zf .... 0: , 1: s
; ==============================================================================
		scope		load_mgs_file
load_mgs_file::
		ld			[file_name_address], de
		ld			a, [de]
		or			a, a				; Zf = 0:, 1:s
		ret			z					; sȂ甲

		call		stop_song

		; G[ϐNA
		xor			a, a
		ld			[error_status], a
		; open the file
		ld			c, D2F_OPEN
		ld			a, 1				; Disable write access
		ld			de, [file_name_address]
		call		safe_bdos
		ld			a, b
		ld			[file_handle], a
		jp			nz, error_exit

		; read the file
		ld			c, D2F_READ
		ld			de, mgs_song_data
		ld			hl, mgs_song_size
		call		safe_bdos

		; close the file
		ld			c, D2F_CLOSE
		ld			a, [file_handle]
		ld			b, a
		call		safe_bdos

		; G[Ȃ甲
		ld			a, [error_status]
		or			a, a
		jp			nz, error_exit

		; check song data
		ld			hl, 0x8000
		call		mgs_datck
		jp			nz, error_exit

		; clear song Title area
		ld			hl, (256 + 32) * 8
		ld			bc, 32 * 8
		xor			a, a
		ld			ix, FILVRM
		ld			iy, [exptbl - 1]
		call		CALSLT
		xor			a, a
		inc			a					; Zf = 0:
		ret
error_exit:
		ld			a, 1
		ld			[error_status], a
		xor			a, a				; Zf = 1:s
		ret
		endscope

; ==============================================================================
;	t@CpXt@Cigq܂܂jRs[
;	input)
;		hl .... t@CpX̃AhX (ASCIIZ)
;		de .... Rs[AhX (9byte)
;	output)
;		--
;	break)
;		af, bc, de, hl
; ==============================================================================
		scope		copy_file_name
copy_file_name::
		; Ō̃pXZp[^ \ 
		ld			c, l
		ld			b, h
search_sep:
		ld			a, [hl]
		inc			hl
		or			a, a
		jr			z, exit_search_sep
		cp			a, '\\'
		jr			nz, search_sep
		jr			copy_file_name

exit_search_sep:
		ld			l, c
		ld			h, b
		ld			b, 8
copy_loop:
		ld			a, [hl]
		inc			hl
		or			a, a
		jr			z, exit_copy_loop
		cp			a, '.'
		jr			z, exit_copy_loop
		ld			[de], a
		inc			de
		djnz		copy_loop
exit_copy_loop:
		xor			a, a
		ld			[de], a
		ret
		endscope

; ==============================================================================
;	ȂĐ
;	output)
;		Zf .... 0: s, 1: 
; ==============================================================================
		scope		play_song
play_song::
		call		stop_song

		; check song data
		ld			hl, 0x8000
		call		mgs_datck
		ret			nz

		; song start
		ld			b, -1
		ld			hl, -1
		ld			de, 0x8000
		call		mgs_plyst
		ei
		xor			a, a
		ret
		endscope

; ==============================================================================
;	Ȃ~
; ==============================================================================
		scope		stop_song
stop_song::
		; song stop
		call		change_mgsdrv_slot
		call		mgs_initm
		ret
		endscope

; ==============================================================================
;	荞ݏ[` ( 0xC000` ɓ]Ďg )
; ==============================================================================
		scope		mgsdrv_h_timi
mgsdrv_h_timi::
		ld			a, [ 0xFFFF ]		; gXbgԍ (page3 ͂łɃvC}}bpXbg)
		cpl								; ǂݏoʂ͔]Ă̂Ŗ߂
		ld			h, a				; pobNAbv
	mgsdrv_exp_slot	:= $ + 1
		ld			a, 0				; page0`3  vC}}bpXbg(TPA)
		ld			[ 0xFFFF ], a		; gXbgύX

		in			a, [ 0xA8 ]			; {Xbgԍ
		ld			l, a				; pobNAbv
	mgsdrv_slot		:= $ + 1
		ld			a, 0				; page0`3  vC}}bpXbg(TPA)
		out			[ 0xA8 ], a			; {XbgύX

		push		hl					; pobNAbvX^bN֕ۑ

		; page1, page2 ̃ZOgԍobNAbv
		call		mapper_get_p1
		ld			b, a
		call		mapper_get_p2
		ld			c, a
		push		bc					; }bp[̃ZOgԍ(page1, page2)ۑ

		; page1, page2  MGSDRV ̃ZOgɐ؂ւ
		ld			a, [mgs_id_drvseg]
		call		mapper_put_p1
		ld			a, [mgs_id_datseg]
		call		mapper_put_p2

		; MGSPŗpJE^[
		ld			a, [timer_counter]
		inc			a
		ld			[timer_counter], a

		; CPUו\
		ld			a, [show_cpu_load_time]
		or			a, a
		jr			z, skip_load_time1
		ld			a, 0x0C
		out			[ vdp_port1 ], a
		ld			a, 0x87
		out			[ vdp_port1 ], a
skip_load_time1:

		; ĐxJE^[CNg
		ld			hl, [song_speed_counter]
		ld			de, [song_speed]
		add			hl, de
		ld			[song_speed_counter], hl

loop1:
		or			a, a
		ld			de, 100
		sbc			hl, de
		jr			c, mgs_inter_skip

		ld			[song_speed_counter], hl

		; MGSDRV Ă
		call		mgs_inter

		ld			hl, [song_speed_counter]
		jr			loop1

mgs_inter_skip:
		; CPUו\
		ld			a, [show_cpu_load_time]
		or			a, a
		jr			z, skip_load_time2
		ld			a, 0x00
		out			[ vdp_port1 ], a
		ld			a, 0x87
		out			[ vdp_port1 ], a
skip_load_time2:

		; page1, page2 ̃}bp[̃ZOgԍ𕜌
		pop			bc
		ld			a, b
		call		mapper_put_p1
		ld			a, c
		call		mapper_put_p2

		; Xbg𕜌
		pop			hl
		ld			a, l
		out			[ 0xA8 ], a			; {Xbgɖ߂
		ld			a, h
		ld			[ 0xFFFF ], a		; gXbgɖ߂
old_h_timi::
		ret
		ret
		ret
		ret
		ret
mgsdrv_h_timi_end::
		endscope

; ==============================================================================
;	WORKAREA
; ==============================================================================
song_speed::
		dw		100		; 2byte: 1%...255% ͈̔͂̂ݗL
song_speed_counter::
		dw		0
backup_segment1::
		db		0
backup_segment2::
		db		0
show_cpu_load_time::
		db		0		; MGSDRVCPUׂ̕\ 0:OFF, 1:ON

file_name_address::
		dw		0
file_name_copy::
		db		0, 0, 0, 0, 0, 0, 0, 0, 0
file_handle::
		db		0

mgs_parameter_block::
mgs_id_drvslt::			; 1byte: MGSDRV{̂̃Xbg
		db			0
mgs_id_drvseg::			; 1byte: MGSDRV{̂̃ZOg
		db			0
mgs_id_datslt::			; 1byte: tf[^̈̃Xbg
		db			0
mgs_id_datseg::			; 1byte: tf[^̈̃ZOg
		db			0
mgs_id_mgsver::			; 2bytes: MGSDRṼo[W
		dw			0
mgs_id_mibadr::			; 2bytes: MIBւ̃AhX
		dw			0
mgs_id_trwadr::			; 2bytes: gbN[ÑAhX
		dw			0
mgs_id_trwsiz::			; 2bytes: gbN[ÑTCY
		dw			0
